/*
 générateur de fréquences DDS AD9850 
 frequence = 60 Hz
 Comptage frequence d'après Peter Marks http://marxy.org
 
 Version 01 Novembre 2013
 Mon site http://f5mna.free.fr
*/
#define DDS_REF 125000000
// DDS/Arduino Connections
#define DDS_LOAD  13  //FQ_UD
#define DDS_CLOCK 3
#define DDS_DATA  2
 
unsigned long freq;

void setup(){
  // Set all pins to output states
  pinMode (DDS_DATA,  OUTPUT);
  pinMode (DDS_CLOCK, OUTPUT);
  pinMode (DDS_LOAD,  OUTPUT); 

  freq = 60; //Fréquence de départ 60 Hz
}
void loop() 
{
  unsigned long tuning_word = (freq * pow(2, 32)) / DDS_REF;  //Formule de calcul fréquence
  digitalWrite (DDS_LOAD, LOW); // pin Load niveau bas 
  int i;
  
  for(i = 0; i < 32; i++) {
    if ((tuning_word & 1) == 1)
      outOne();
    else
      outZero();
    tuning_word = tuning_word >> 1;
  }
  byte_out(0x08);
  digitalWrite (DDS_LOAD, HIGH); // remet la Pin "Load" au niveau haut

}

void byte_out(unsigned char byte) { //découpe en octets la valeur sur 32 bits
  int i;
  for (i = 0; i < 8; i++) {
    if ((byte & 1) == 1)
      outOne();
    else
      outZero();
    byte = byte >> 1;
  }
}

void outOne() {  // Contrôle des entrées Data dans le CI AD9850
  digitalWrite(DDS_CLOCK, LOW);
  digitalWrite(DDS_DATA, HIGH);
  digitalWrite(DDS_CLOCK, HIGH);
  digitalWrite(DDS_DATA, LOW);
}

void outZero() {
  digitalWrite(DDS_CLOCK, LOW);
  digitalWrite(DDS_DATA, LOW);
  digitalWrite(DDS_CLOCK, HIGH);
}



